//
//  GridViewTemplateViewController.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/18/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import UIKit
import RxSwift
import RxCocoa
import RxDataSources

public class GridCollectionViewFlowLayout: UICollectionViewFlowLayout {
    
    private var numberOfColumns: Int = 0
    private var contentCellHeight: CGFloat = 0
    private var cellPadding: CGFloat = 0
    
    private var contentWidth: CGFloat {
        
        guard let collectionView = collectionView else { return .zero }
        
        let insets = collectionView.contentInset
        let collectionViewWidth = collectionView.bounds.width
        
        return collectionViewWidth - (insets.left + insets.right)
    }
    
    private var cellWidth: CGFloat {
        let columns = CGFloat(numberOfColumns)
        return (contentWidth - (columns - 1) * cellPadding) / columns
    }
    
    private var cellHeight: CGFloat = 0

    override public func prepare() {
        super.prepare()
        itemSize = CGSize(width: cellWidth, height: cellHeight)
        minimumLineSpacing = cellPadding
    }

    override public func invalidationContext(forBoundsChange newBounds: CGRect) -> UICollectionViewLayoutInvalidationContext {
        guard let context = super.invalidationContext(forBoundsChange: newBounds) as? UICollectionViewFlowLayoutInvalidationContext else {
            return UICollectionViewLayoutInvalidationContext()
        }
        context.invalidateFlowLayoutDelegateMetrics = newBounds.size != collectionView?.bounds.size
        return context
    }
    
    @discardableResult
    public func setCellPadding(_ padding: CGFloat) -> GridCollectionViewFlowLayout {
        self.cellPadding = padding
        return self
    }
    
    @discardableResult
    public func setCellHeight(_ value: CGFloat) -> GridCollectionViewFlowLayout {
        self.cellHeight = value
        return self
    }
    
    @discardableResult
    public func setNumberOfColumns(_ value: Int) -> GridCollectionViewFlowLayout {
        self.numberOfColumns = value
        return self
    }
    
    @discardableResult
    public func setScrollDirection(_ direction: UICollectionView.ScrollDirection) -> GridCollectionViewFlowLayout {
        scrollDirection = direction
        return self
    }
}


final class GridViewTemplateViewController: UIViewController, GridViewTemplateViewInterface {

    let viewModels = BehaviorRelay<[ProductCarouselCellViewModel]>(value: [])
    private lazy var dataSource = makeDataSource()
    
    @IBOutlet private weak var titleLabel: UILabel!
    @IBOutlet private weak var collectionView: UICollectionView!
    @IBOutlet private weak var collectionViewHeightConstraint: NSLayoutConstraint!
    // MARK: - Public properties -
    
    /// Internal
    private let viewDidLoadRelay = BehaviorRelay(value: false)
    private let disposeBag = DisposeBag()

    var presenter: GridViewTemplatePresenterInterface!

    // MARK: - Lifecycle -

    override func viewDidLoad() {
        super.viewDidLoad()
        defer {
            viewDidLoadRelay.accept(true)
        }
        configureViews()
        configurePresenter()
    }

}

// MARK: - Extensions -
// MARK: - Extensions -
extension GridViewTemplateViewController {
    private func configureViews() {
        
        titleLabel.setStyle(DS.T16M(color: Colors.ink500))
        configureCollectionView()
    }
    
    private func configureCollectionView() {
        
        collectionViewHeightConstraint.constant = UIConfig.collectionViewHeight
        let collectionViewLayout = GridCollectionViewFlowLayout()
            .setCellPadding(UIConfig.cellPadding)
            .setNumberOfColumns(2)
            .setScrollDirection(.vertical)
            .setCellHeight(UIConfig.cellHeight)
        
        collectionView.collectionViewLayout = collectionViewLayout
        collectionView.isScrollEnabled = false
        
        collectionView.showsVerticalScrollIndicator = false
        collectionView.showsHorizontalScrollIndicator = false
        collectionView.contentInset = UIEdgeInsets(top: .zero, left: UIConfig.cellPadding, bottom: .zero, right: UIConfig.cellPadding)
        
        registerCells()
    }
    
    private func registerCells() {
        collectionView.register(cellType: ProductGridCell.self)
    }
    
    enum UIConfig {
        static let cellPadding: CGFloat = 16
        static let cellWidth: CGFloat = (UIScreen.main.bounds.width - (16 * 3)) / 2
        static let cellHeight: CGFloat = cellWidth * 3 / 4 + 100
        static let collectionViewHeight = cellHeight * 2 + 16
    }
}

extension GridViewTemplateViewController {
    private func configurePresenter() {
        let didLoad = viewDidLoadRelay.asObservable()
        
        viewModels
            .filterEmpty()
            .takeLatestWhen(didLoad)
            .map { $0.count }
            .map { [weak self] totalItem -> CGFloat in
                return (self?.getCollectionViewHeight(by: totalItem)).or(.zero)
            }
            .asDriver(onErrorDriveWith: .never())
            .driveNext { [weak self] height in
                self?.collectionViewHeightConstraint.constant = height
            }
            .disposed(by: disposeBag)
            
        viewModels
            .filterEmpty()
            .takeLatestWhen(didLoad)
            .map { [Section(model: 0, items: $0)] }
            .asDriver(onErrorDriveWith: .never())
            .drive(collectionView.rx.items(dataSource: dataSource))
            .disposed(by: disposeBag)
    }
    
    func getCollectionViewHeight(by totalItem: Int) -> CGFloat {
        let numberOfRows = CGFloat( totalItem / 2 )
        return numberOfRows * UIConfig.cellHeight + (numberOfRows - 1) * UIConfig.cellPadding
    }
}


extension GridViewTemplateViewController {
    typealias Section = SectionModel<Int, ProductCarouselCellViewModel>
    typealias DataSource = RxCollectionViewSectionedReloadDataSource<Section>
}

extension GridViewTemplateViewController {
    func makeDataSource() -> DataSource {
        return DataSource { (_, collectionView, indexPath, model) -> UICollectionViewCell in
            let cell: ProductGridCell = collectionView.dequeueReusableCell(for: indexPath)
            return cell
        }
    }
}

